#################################################################
#								#
# Copyright (c) 2019-2021 YottaDB LLC and/or its subsidiaries.	#
# All rights reserved.						#
#								#
#	This source code contains the intellectual property	#
#	of its copyright holder(s), and is made available	#
#	under a license.  If you do not know the terms of	#
#	the license, please stop and do not read further.	#
#								#
#################################################################

load test_helpers

setup() {
  init_test
  createdb
  test_port=$(start_rocto 1344)
}

teardown() {
	stop_rocto
}

@test "TOJ01 : Various OUTER JOIN queries (including OCTO363)" {
  load_fixture names.sql
  load_fixture names.zwr
  cp @PROJECT_SOURCE_DIR@/tests/fixtures/TOJ01.sql .
  yottadb -run genqueryfiles TOJ01.sql	# this generates query files of the form TOJ01_01.sql, TOJ01_02.sql ...
  for file in TOJ01_*.sql
  do
    run_query_in_octo_and_postgres_and_crosscheck_multiple_queries names $file
  done
}

@test "TOJ02 : LEFT/RIGHT/FULL JOIN on various queries from pastas database" {
  load_fixture pastas.sql
  load_fixture pastas.zwr
  # Below are all queries that were found in the following files.
  #	test_inner_join_order_by.bats.in
  #	test_inner_join_where.bats.in
  #	test_inner_join_where_order_by.bats.in
  # Each of those queries are run with a LEFT or RIGHT or FULL JOIN and the output is compared against Postgres.
  # This simplifies the task of maintaining reference files for these.
  yottadb -run TOJ02	# this generates queries of the form jointest01.sql, jointest02.sql ...
  # Run using psql and Octo against each of the generated queries
  for file in jointest*.sql
  do
    run_query_in_octo_and_postgres_and_crosscheck_multiple_queries pastas $file
  done
}

@test "TOJ03 : random outer join queries" {
	load_fixture customers.sql
	load_fixture customers.zwr
	# 8 below is max # of inner/outer joins in one query
	yottadb -run TOJ03 8 > TOJ03.sql
	# Run using psql and Octo against each of the generated queries
	run_query_in_octo_and_postgres_and_crosscheck_multiple_queries customers TOJ03.sql
}

@test "TOJ04 : outer join with no ON condition specified" {
  load_fixture names.sql
  load_fixture names.zwr
  cp @PROJECT_SOURCE_DIR@/tests/fixtures/TOJ04.sql .	# contains only one query
  yottadb -run genqueryfiles TOJ04.sql	# this generates the query file TOJ04_01.sql (only one)
  cat TOJ04_*.sql > output.txt
  run_octo_allow_error TOJ04_*.sql output.txt
  verify_output TOJ04 output.txt
}

@test "TOJ05 : OCTO312 : Use WHERE clause to optimize LEFT JOIN (just like INNER JOIN)" {
  load_fixture vista-mini.sql
  # load M functions needed by the query
  load_fixture TOJ05.sql subtest novv
  echo "# Verify cross reference plans did get generated" >> output.txt
  ls -1 _ydboctoX*.m >> output.txt
  echo "# Verify key fixing optimization happened by looking at the FOR loops in the generated M code" >> output.txt
  grep -B 2 -E "ydboctoX|octoPlan|FOR" _ydboctoP*.m >> output.txt
  verify_output TOJ05 output.txt
}

@test "TOJ06 : OCTO312 : Use WHERE clause to optimize RIGHT JOIN (just like INNER JOIN)" {
  load_fixture vista-mini.sql
  # load M functions needed by the query
  load_fixture TOJ06.sql subtest novv
  echo "# Verify cross reference plans did get generated" >> output.txt
  ls -1 _ydboctoX*.m >> output.txt
  echo "# Verify key fixing optimization happened by looking at the FOR loops in the generated M code" >> output.txt
  grep -B 2 -E "ydboctoX|octoPlan|FOR" _ydboctoP*.m >> output.txt
  verify_output TOJ06 output.txt
}

@test "TOJ07 : OCTO312 : Use WHERE clause to optimize FULL JOIN (just like INNER JOIN)" {
  load_fixture vista-mini.sql
  # load M functions needed by the query
  load_fixture TOJ07.sql subtest novv
  echo "# Verify cross reference plans did get generated" >> output.txt
  ls -1 _ydboctoX*.m >> output.txt
  echo "# Verify key fixing optimization happened by looking at the FOR loops in the generated M code" >> output.txt
  grep -B 2 -E "ydboctoX|octoPlan|FOR" _ydboctoP*.m >> output.txt
  verify_output TOJ07 output.txt
}

@test "TOJ08 : OCTO534 : customers schema : Incorrect query results when LEFT/RIGHT/FULL JOIN is used with OR in WHERE clause" {
  load_fixture customers.sql
  load_fixture customers.zwr
  run_query_in_octo_and_postgres_and_crosscheck_multiple_queries customers TOJ08.sql
}

@test "TOJ09 : OCTO534 : northwind schema : Incorrect query results when LEFT/RIGHT/FULL JOIN is used with OR in WHERE clause" {
  load_fixture northwind.sql
  load_fixture northwind.zwr
  run_query_in_octo_and_postgres_and_crosscheck_multiple_queries northwind TOJ09.sql
}

@test "TOJ10 : OCTO706 : customers schema : Incorrect query results when RIGHT/FULL JOIN is used with OR in WHERE clause" {
  load_fixture customers.sql
  load_fixture customers.zwr
  run_query_in_octo_and_postgres_and_crosscheck_multiple_queries customers TOJ10.sql
}

